package com.ruoyi.mall.service;

import java.util.List;
import java.util.Map;

import com.ruoyi.mall.domain.MallCompanyUser;
import com.ruoyi.mall.domain.MallDevice;

/**
 * 设备Service接口
 *
 * @author LCL
 * @date 2024-03-17
 */
public interface IMallDeviceService
{
    /**
     * 查询设备
     *
     * @param deviceId 设备主键
     * @return 设备
     */
    public MallDevice selectMallDeviceByDeviceId(Long deviceId);

    /**
     * 查询设备列表
     *
     * @param mallDevice 设备
     * @return 设备集合
     */
    public List<MallDevice> selectMallDeviceList(MallDevice mallDevice);

    /**
     * 新增设备
     *
     * @param mallDevice 设备
     * @return 结果
     */
    public int insertMallDevice(MallDevice mallDevice);

    /**
     * 修改设备
     *
     * @param mallDevice 设备
     * @return 结果
     */
    public int updateMallDevice(MallDevice mallDevice);

    /**
     * 批量删除设备
     *
     * @param deviceIds 需要删除的设备主键集合
     * @return 结果
     */
    public int deleteMallDeviceByDeviceIds(Long[] deviceIds);

    /**
     * 删除设备信息
     *
     * @param deviceId 设备主键
     * @return 结果
     */
    public int deleteMallDeviceByDeviceId(Long deviceId);

    /**
     * APP查询设备列表
     *
     * @param params 参数
     * @return 设备集合
     */
    public List<Map<String, Object>> selectAppMallDeviceList(Map<String, Object> params);

    /**
     * 根据设备类型获取设备名
     *
     * @param deviceType 设备类型：0-无，1-报警主机，2-摄像头，3-弹箱，4-语音喇叭，5-电源
     * @return 结果
     */
    public String selectMallDeviceNameByDeviceType(String deviceType);

    /**
     * APP查询弹箱统计列表
     *
     * @param params 参数
     * @return 设备集合
     */
    public List<Map<String, Object>> selectAppMallDeviceBoxList(Map<String, Object> params);

    /**
     * 根据序列号查询设备
     *
     * @param serialNumber 序列号
     * @return 设备
     */
    public MallDevice selectMallDeviceBySerialNumber(String serialNumber);

    /**
     * 处理接收的数据
     *
     * @param message 数据
     * @return 结果
     */
    public Map<String, Object> processingReceivedData(String message);

    /**
     * 接收发来的数据-回应
     *
     * @param ability 功能
     * @param serialNumber 序列号
     * @param handshake 握手
     * @return 结果
     */
    public String receivedDataResponse(String ability, String serialNumber, String handshake);
}
